'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getLinesAround = undefined;

var _stackFrame = require('stack-frame');

/**
 *
 * @param {number} line The line number to provide context around.
 * @param {number} count The number of lines you'd like for context.
 * @param {string[] | string} lines The source code.
 */
function getLinesAround(line, count, lines) {
  if (typeof lines === 'string') {
    lines = lines.split('\n');
  }
  var result = [];
  for (var index = Math.max(0, line - 1 - count); index <= Math.min(lines.length - 1, line - 1 + count); ++index) {
    result.push(new _stackFrame.ScriptLine(index + 1, lines[index], index === line - 1));
  }
  return result;
}
exports.getLinesAround = getLinesAround;
exports.default = getLinesAround;